<template>
<div>
    <ol class="breadcrumb">
        <!-- <a class="btn btn-success" hrefฃฃฃฃ="http://localhost:8000/employee/viewcreate"> เพิ่มรายการ </a> -->
        <div @click="createProduct()" class="btn btn-success" >
            <div data-i18n="3">เพิ่มรายการ</div>
        </div>
    </ol>
    <div class="card">

        <!-- <button @click="showEditProduct()">12312</button> -->

        <div class="card-header card_header_admin">
            <h5 class="mt-3 ms-2">รายการสินค้า ({{global_name_type_product}})</h5>
        </div>
        <div class="card-body mt-3">
            <table id="table_order_price">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>code</th>
                        <th>ชื่อไทย</th>
                        <th>หน่วย</th>
                        <th>รูป</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>



        <!-- Button trigger modal -->
    <!-- <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#staticBackdrop">
        Launch static backdrop modal
    </button> -->

    <!-- Modal -->
    <form id="form_edit" enctype="multipart/form-data">
        <div class="modal fade" id="staticBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
            <div class="modal-dialog modal-xl">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="staticBackdropLabel">แก้ไขรายการสินค้า</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">

                        <input type="hidden" id="id_product" name="id_product">

                        <div class="row">
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="type_product" class="form-label">ประเภทสินค้า</label>
                                    <input type="text" class="form-control" id="type_product" name="type_product" placeholder=""  readonly>
                                </div>
                            </div>


                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="unit" class="form-label">หน่วย</label>
                                    <select class="form-select" id="type_unit" aria-label="unit" name="type_unit" required>
                                        <option selected value="">-- เลือก --</option>
                                        <option v-for="item in global_unit_list" :key="item.id" :value="item.id">
                                            {{ item.name_th }}
                                        </option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="brand" class="form-label">แบรนด์</label>
                                    <select class="form-select" id="type_brand" aria-label="brand" name="type_brand" required>
                                        <option selected value="">-- เลือก --</option>
                                        <option v-for="item in global_brand_list" :key="item.id" :value="item.id">
                                            {{ item.name_th }}
                                        </option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="name_th" class="form-label">ชื่อไทย</label>
                                    <input type="text" class="form-control" id="name_th" placeholder="" name="name_th" required>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="name_en" class="form-label">ชื่ออังกฤษ</label>
                                    <input type="text" class="form-control" id="name_en" placeholder="" name="name_en" required>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="code" class="form-label">code</label>
                                    <input type="text" class="form-control" id="code" placeholder="" name="code" required>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="price" class="form-label">ราคา</label>
                                    <input type="number" class="form-control" id="price" placeholder="" name="price" required>
                                </div>
                            </div>
                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="amount" class="form-label">จำนวน</label>
                                    <input type="number" class="form-control" id="amount" placeholder="" name="amount" required>
                                </div>
                            </div>

                            <div class="col-4">
                                <div class="mb-3">
                                    <label for="status" class="form-label">สถานะ</label>
                                    <select class="form-select" aria-label="status" id="status" name="status">
                                        <option value="1"> ใช้งาน </option>
                                        <option value="2"> ไม่ใช้งาน </option>
                                    </select>
                                </div>
                            </div>

                            <div class="col-12">
                                <div class="mb-3">
                                    <label for="discription" class="form-label">คำอธิบาย</label>
                                    <textarea class="form-control" id="discription" name="discription" rows="3"></textarea>
                                </div>
                            </div>
                        </div>



                        <div class="row" id="div_img">

                        </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
                </div>
            </div>
        </div>
    </form>


</div>
</template>




<script>


    var table = '';
    var type_product = null;

    $(document).on("click",".edit_product",function() {
        let id = $(this).data('id');
        showEditProduct(id);

    });

    $(document).on("click",".cancel_status",function() {
        let id = $(this).data('id');
        $('#id_order').val(id);
    });

    function showEditProduct(id) {
        // myModal.show();
        $('#div_img').html('');
        var origin   = window.location.origin;

        axios.get( 'api/product/show/edit/'+id,
        {
            headers: {
                'Content-Type': 'multipart/form-data'
            }
        }
        )
        .then(response =>{

            $('#id_product').val(response.data.id);
            $('#type_unit').val(response.data.id_product_unit);
            $('#type_brand').val(response.data.id_product_brand);
            $('#type_product').val(response.data.type_product.name_th);
            $('#name_th').val(response.data.name_th);
            $('#name_en').val(response.data.name_en);
            $('#code').val(response.data.code);
            $('#price').val(response.data.price);
            $('#amount').val(response.data.amount);
            $('#status').val(response.data.status);
            $('#discription').val(response.data.discription);

            $('#div_img').html(`<input type="file" class="dropify" name="file" data-max-file-size="5M" data-height="300" id="file" ref="file"/>`);
            $('.dropify').dropify({
                defaultFile: origin+'/product/'+response.data.image ,
            });
        }).catch(err =>{
            console.log(err);
        })


        $("#staticBackdrop").modal('show');
    };

    export default {
        data(){
            return{
                id:null,

                file_img:null,
                //from
                name_th:null,
                name_en:null,
                type_brand:null,
                type_unit:null,
                code:null,
                price:null,
                amount:null,
                status:1,

            }
        },
        methods:{
            runFuntion(){
                type_product = this.$route.params.type;
                this.globalGetUnit();
                this.globalGetBrand();
                this.globalAddToken();
                this.globalCheckTypeProduct(this.$route.params.type);
            },

            testTable(){
                table.ajax.url( '/api/product/list/'+ this.$route.params.type).load();
            },
            createProduct(){
                this.$router.push('/product/create/salad/'+this.$route.params.type);
            },
        },
        computed:{

        },
        mounted() {
            this.runFuntion();

        },
        watch: {
            '$route' () {
                this.globalCheckTypeProduct(this.$route.params.type)
                this.testTable();
            }
        },
        created(){



            $(document).ready(function () {

                $('#form_edit').submit(function(event) {
                    event.preventDefault();

                    var form = $('#form_edit')[0];
                    var data = new FormData(form);

                    data.append('file', $('input[type=file]')[0].files[0]);

                    axios.post( 'api/product/edit',
                    data,
                    {
                        headers: {
                            'Content-Type': 'multipart/form-data'
                        }
                    }
                    )
                    .then(response =>{
                        $("#staticBackdrop").modal('hide');
                        table.ajax.reload();
                        Swal.fire(
                            'บันทึกข้อมูลสำเร็จ!',
                            '',
                            'success'
                        )
                    }).catch(err =>{
                        Swal.fire(
                            'บันทึกไม่สำเร็จ!',
                            'กรุณาลองอีกครั้ง',
                            'error'
                        )
                    })

                })

                $('.select-single').select2();
                $('.dropify').dropify();

                table = $('#table_order_price').DataTable({
                    processing: true,
                    serverSide: true,
                    ajax: '/api/product/list/'+type_product,
                    columns: [
                        {
                            data:"id"
                        },
                        {
                            data:"code"
                        },
                        {
                            data:"name_th"
                        },
                        {
                            data:"type_unit.name_th"
                        },
                        {
                            data: "image",
                            render: function ( data, type, row ) {

                                return `
                                    <img src="/product/${data}" alt="" style="width: 90px;">
                                `;


                            }
                        },
                        {
                            data: "id",
                            render: function ( data, type, row ) {

                                // <button type="button" class="btn btn-danger delete_product" data-id="${row['id']}">ลบ</button>
                                return `
                                    <button type="button" class="btn btn-warning edit_product" data-id="${row['id']}">แก้ไข</button>
                                `;


                            }
                        },
                    ],

                })

            });


        }
    }

</script>



